Index: tmp/org.txm.index.core/src/org/txm/index/core/preferences/IndexPreferences.java
===================================================================
--- tmp/org.txm.index.core/src/org/txm/index/core/preferences/IndexPreferences.java	(revision 2730)
+++ tmp/org.txm.index.core/src/org/txm/index/core/preferences/IndexPreferences.java	(revision 2731)
@@ -24,6 +24,11 @@
 	public static final String N_TOP_INDEX = "n_top_index"; //$NON-NLS-1$
 	
 	/**
+	 * if true the links from index will create a subcorpus of the index occurrences
+	 */
+	public static final String LINK_USING_SUBCORPUS = "link_using_subcorpus";
+	
+	/**
 	 * Gets the instance.
 	 * 
 	 * @return the instance
@@ -49,6 +54,6 @@
 		preferences.putInt(F_MAX, Integer.MAX_VALUE);
 		preferences.putInt(V_MAX, Integer.MAX_VALUE);
 		preferences.putInt(N_LINES_PER_PAGE, 100);
-		
+		preferences.putBoolean(LINK_USING_SUBCORPUS, false);
 	}
 }
Index: tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java
===================================================================
--- tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java	(revision 2730)
+++ tmp/org.txm.index.rcp/src/org/txm/index/rcp/editors/IndexEditor.java	(revision 2731)
@@ -38,7 +38,6 @@
 import org.eclipse.swt.graphics.FontData;
 import org.eclipse.swt.layout.GridData;
 import org.eclipse.swt.layout.GridLayout;
-import org.eclipse.swt.layout.RowLayout;
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.Display;
 import org.eclipse.swt.widgets.Label;
@@ -535,7 +534,6 @@
 	 */
 	@Override
 	public void _setFocus() {
-		super.setFocus();
 		if (this.queryWidget != null && !this.queryWidget.isDisposed()) {
 			this.queryWidget.setFocus();
 		}
Index: tmp/org.txm.index.rcp/src/org/txm/index/rcp/preferences/IndexPreferencesPage.java
===================================================================
--- tmp/org.txm.index.rcp/src/org/txm/index/rcp/preferences/IndexPreferencesPage.java	(revision 2730)
+++ tmp/org.txm.index.rcp/src/org/txm/index/rcp/preferences/IndexPreferencesPage.java	(revision 2731)
@@ -1,5 +1,6 @@
 package org.txm.index.rcp.preferences;
 
+import org.eclipse.jface.preference.BooleanFieldEditor;
 import org.eclipse.jface.preference.IntegerFieldEditor;
 import org.eclipse.ui.IWorkbench;
 import org.txm.core.preferences.TXMPreferences;
@@ -28,5 +29,7 @@
 	@Override
 	protected void createFieldEditors() {
 		this.addField(new IntegerFieldEditor(TXMPreferences.N_LINES_PER_PAGE, IndexUIMessages.numberOfLinesPerResultPage, this.getFieldEditorParent()));
+		
+		this.addField(new BooleanFieldEditor(IndexPreferences.LINK_USING_SUBCORPUS, "Experimental: create a subcorpus when calling a command from an index", this.getFieldEditorParent()));
 	}
 }
Index: tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/editors/ProgressionEditor.java
===================================================================
--- tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/editors/ProgressionEditor.java	(revision 2730)
+++ tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/editors/ProgressionEditor.java	(revision 2731)
@@ -568,9 +568,6 @@
 				queryWidget.setFocus();
 			}
 		}
-		else {
-			super.setFocus();
-		}
 	}
 	
 	/**
Index: tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/chartsengine/events/ProgressionEventCallBack.java
===================================================================
--- tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/chartsengine/events/ProgressionEventCallBack.java	(revision 2730)
+++ tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/chartsengine/events/ProgressionEventCallBack.java	(revision 2731)
@@ -211,13 +211,13 @@
 		
 		
 		
-		final TXMResultEditorInput editorInput;
+		final TXMResultEditorInput<Concordance> editorInput;
 		boolean newEditor = false;
 		// Create the linked editor input if needed
 		if (linkedEditor == null) {
 			Concordance concordance = new Concordance(((Progression) chartEditor.getResult()).getCorpus());
 			concordance.setQuery(query);
-			editorInput = new TXMResultEditorInput(concordance);
+			editorInput = new TXMResultEditorInput<>(concordance);
 			newEditor = true;
 		}
 		else {
@@ -412,7 +412,7 @@
 				return;
 			}
 			
-			Edition edition = text.getEdition(corpus.getProject().getDefaultEdition());
+			Edition edition = text.getEdition(corpus.getProject().getDefaultEditionName());
 			
 			if (edition == null) {
 				Log.severe(ProgressionUIMessages.defaultEditionIsMissing);
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/MainCorpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/MainCorpus.java	(revision 2730)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/MainCorpus.java	(revision 2731)
@@ -84,7 +84,7 @@
 	 * 
 	 * @param partition the parent partition -> only used for subcorpus
 	 */
-	// FIXME: SJ: not used anymore?
+	// FIXME: SJ: not used anymore? MD: this is a temporary solution to build Parts using a Partition (a Part is a CQPCorpus, etc.)
 	public MainCorpus(Partition partition) {
 		super(partition);
 		throw new IllegalArgumentException("Maincorpus parent must not be a Partition");
Index: tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/handlers/OpenEdition.java
===================================================================
--- tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/handlers/OpenEdition.java	(revision 2730)
+++ tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/handlers/OpenEdition.java	(revision 2731)
@@ -124,7 +124,7 @@
 	}
 	
 	public static String[] getDefaultEditions(Project p) {
-		return p.getDefaultEdition().split(","); //$NON-NLS-1$
+		return p.getDefaultEditionName().split(","); //$NON-NLS-1$
 	}
 	
 	public static String[] getDefaultEditions(CQPCorpus c) {
Index: tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/handlers/BackToText.java
===================================================================
--- tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/handlers/BackToText.java	(revision 2730)
+++ tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/handlers/BackToText.java	(revision 2731)
@@ -47,6 +47,7 @@
 import org.txm.concordance.core.functions.Concordance;
 import org.txm.concordance.rcp.editors.ConcordanceEditor;
 import org.txm.concordance.rcp.handlers.BackToTextCommand;
+import org.txm.core.results.TXMResult;
 import org.txm.edition.rcp.editors.RGBA;
 import org.txm.edition.rcp.editors.SynopticEditionEditor;
 import org.txm.edition.rcp.messages.EditionUIMessages;
@@ -54,6 +55,7 @@
 import org.txm.objects.Match;
 import org.txm.objects.Text;
 import org.txm.rcp.StatusLine;
+import org.txm.rcp.editors.TXMEditor;
 import org.txm.rcp.utils.SWTEditorsUtils;
 import org.txm.searchengine.core.SearchEngine;
 import org.txm.searchengine.cqp.AbstractCqiClient;
@@ -66,29 +68,34 @@
 import org.txm.utils.logger.Log;
 
 /**
- * Open a text edition from: a concordance Line 
+ * Open a text edition from: a concordance Line
  * 
  * Or Open a text edition from command parameters see plugin.xml
  * 
  * @author mdecorde.
  */
 public class BackToText extends BackToTextCommand {
-
+	
 	/** The Constant ID. */
 	public final static String ID = "org.txm.synopticedition.rcp.handlers.BackToText"; //$NON-NLS-1$
-	public final static RGBA lightred = new RGBA(249,208,208);
+	
+	public final static RGBA lightred = new RGBA(249, 208, 208);
+	
 	public final static RGBA red = new RGBA(249, 160, 160);
-	//TODO: this kind of link associations must be transfered to a TXMEditor class
-	//private static HashMap<ConcordanceEditor, SynopticEditionEditor> associatedEditors = new HashMap<ConcordanceEditor, SynopticEditionEditor>();
-	private static HashMap<ConcordanceEditor, List<String>> associatedEditorsPreviousOtherWordIDs = new HashMap<ConcordanceEditor, List<String>>();
-	private static HashMap<ConcordanceEditor, List<String>> associatedEditorsPreviousLineids = new HashMap<ConcordanceEditor, List<String>>();
-
-	/* (non-Javadoc)
+	
+	// TODO: this kind of link associations must be transfered to a TXMEditor class
+	// private static HashMap<ConcordanceEditor, SynopticEditionEditor> associatedEditors = new HashMap<ConcordanceEditor, SynopticEditionEditor>();
+	private static HashMap<ConcordanceEditor, List<String>> associatedEditorsPreviousOtherWordIDs = new HashMap<>();
+	
+	private static HashMap<ConcordanceEditor, List<String>> associatedEditorsPreviousLineids = new HashMap<>();
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands.ExecutionEvent)
 	 */
 	@Override
 	public Object execute(ExecutionEvent event) throws ExecutionException {
-
+		
 		String wordid = event
 				.getParameter("org.txm.edition.rcp.handlers.BackToText.wordid");
 		String textid = event
@@ -101,82 +108,85 @@
 			try {
 				IWorkbenchWindow wb = HandlerUtil.getActiveWorkbenchWindow(event);
 				IEditorPart ieditor = wb.getActivePage().getActiveEditor();
-
+				
 				if (!backToText(ieditor, corpusid, Arrays.asList(editionid.split("|")), textid, wordid)) {
-					System.out.println("Could not open edition for wordid="+wordid+" textid="+textid+" edition="+editionid);
+					System.out.println("Could not open edition for wordid=" + wordid + " textid=" + textid + " edition=" + editionid);
 				}
-			} catch (Exception e) {
+			}
+			catch (Exception e) {
 				// TODO Auto-generated catch block
 				e.printStackTrace();
 			}
 			return null;
 		}
-
+		
 		IWorkbenchWindow wb = HandlerUtil.getActiveWorkbenchWindow(event);
 		IEditorPart ieditor = wb.getActivePage().getActiveEditor();
 		if (!(ieditor instanceof ConcordanceEditor)) {
 			return null;
 		}
-		ConcordanceEditor concordanceEditor = (ConcordanceEditor)ieditor;
+		ConcordanceEditor concordanceEditor = (ConcordanceEditor) ieditor;
 		// FIXME: SJ: new version
 		concordanceEditor.backToText();
 		// FIXME: SJ: old version
-//		ISelection sel = wb.getSelectionService().getSelection();
-//		if (sel instanceof IStructuredSelection) {
-//			IStructuredSelection selection = (IStructuredSelection) sel;
-//			if (selection.getFirstElement() instanceof Match) {
-//				backToText(concordanceEditor, (Match)(selection.getFirstElement()));
-//			} else {
-//				System.out.println(SynopticEditionUIMessages.BackToText_1+selection);
-//			}
-//		} else {
-//			System.out.println(SynopticEditionUIMessages.BackToText_2);
-//		}
+		// ISelection sel = wb.getSelectionService().getSelection();
+		// if (sel instanceof IStructuredSelection) {
+		// IStructuredSelection selection = (IStructuredSelection) sel;
+		// if (selection.getFirstElement() instanceof Match) {
+		// backToText(concordanceEditor, (Match)(selection.getFirstElement()));
+		// } else {
+		// System.out.println(SynopticEditionUIMessages.BackToText_1+selection);
+		// }
+		// } else {
+		// System.out.println(SynopticEditionUIMessages.BackToText_2);
+		// }
 		return null;
 	}
-
+	
 	private boolean backToText(IEditorPart ieditor, String corpusid, List<String> editions, String textid, String wordid) throws Exception {
 		MainCorpus corpus = CorpusManager.getCorpusManager().getCorpus(corpusid);
-
+		
 		if (corpus == null) {
-			System.out.println("Error: no corpus with ID="+corpusid);
+			System.out.println("Error: no corpus with ID=" + corpusid);
 		}
-
+		
 		if (editions != null && !corpus.getProject().getBuiltEditionNames().containsAll(editions)) {
-			System.out.println("Warning: corpus has no edition with id="+editions);
+			System.out.println("Warning: corpus has no edition with id=" + editions);
 			editions = Arrays.asList("default");
 		}
-
+		
 		if (!corpus.getProject().getBuiltEditionNames().containsAll(editions)) {
 			System.out.println("Error: corpus has no default edition.");
-			System.out.println("Availables: "+corpus.getProject().getEditionNames());
+			System.out.println("Availables: " + corpus.getProject().getEditionNames());
 			return false;
 		}
-
+		
 		SynopticEditionEditor editor = null;
 		boolean newEditor = false;
 		if (ieditor != null && ieditor instanceof SynopticEditionEditor) {
-			editor = (SynopticEditionEditor)ieditor;
-		} else {
+			editor = (SynopticEditionEditor) ieditor;
+		}
+		else {
 			editor = OpenEdition.openEdition(corpus, editions);
 			newEditor = true;
 		}
-
+		
 		Text text = null;
 		if (textid != null) {
 			text = corpus.getProject().getText(textid);
 			if (text == null) {
-				System.out.println("Error: corpus has no text with id="+textid);
+				System.out.println("Error: corpus has no text with id=" + textid);
 				return false;
 			}
-		} else {
+		}
+		else {
 			text = corpus.getProject().getFirstText();
 			if (text == null) {
 				System.out.println("Error: corpus has no text.");
 				return false;
 			}
 		}
-
+		
 		editor.backToText(text, wordid);
 		if (wordid != null) {
 			editor.addHighlightWordsById(red, wordid);
@@ -184,7 +194,7 @@
 		editor.updateWordStyles();
 		return false;
 	}
-
+	
 	/**
 	 * Open edition.
 	 *
@@ -199,13 +209,13 @@
 		
 		try {
 			if (match == null) return false;
-
+			
 			StructuralUnit textS = null;
 			String textid = ""; //$NON-NLS-1$
 			String baseid = ""; //$NON-NLS-1$
-
+			
 			Property xProperty = corpus.getProperty("x"), yProperty, wProperty, hProperty;
-			String x="0",y="0",w="0",h="0";
+			String x = "0", y = "0", w = "0", h = "0";
 			int[] pos = null;
 			if (xProperty != null) {
 				yProperty = corpus.getProperty("y");
@@ -213,14 +223,14 @@
 					wProperty = corpus.getProperty("w");
 					if (wProperty != null) {
 						AbstractCqiClient CQI = CQPSearchEngine.getCqiClient();
-						int[] cpos = {match.getStart()};
+						int[] cpos = { match.getStart() };
 						hProperty = corpus.getProperty("h");
 						if (hProperty != null) {
 							x = CQI.cpos2Str(xProperty.getQualifiedName(), cpos)[0];
 							y = CQI.cpos2Str(yProperty.getQualifiedName(), cpos)[0];
 							w = CQI.cpos2Str(wProperty.getQualifiedName(), cpos)[0];
 							h = CQI.cpos2Str(hProperty.getQualifiedName(), cpos)[0];
-
+							
 							pos = new int[4];
 							pos[0] = Integer.parseInt(x);
 							pos[1] = Integer.parseInt(y);
@@ -230,130 +240,135 @@
 					}
 				}
 			}
-
-
+			
+			
 			String projectid = ""; //$NON-NLS-1$
 			try {
 				textS = corpus.getStructuralUnit("text"); //$NON-NLS-1$
 				Property textP = textS.getProperty("id"); //$NON-NLS-1$
-				textid = org.txm.searchengine.cqp.corpus.query.Match.getValueForProperty(textP, match.getStart()); //$NON-NLS-1$
-			} catch (Exception e2) {
+				textid = org.txm.searchengine.cqp.corpus.query.Match.getValueForProperty(textP, match.getStart());
+			}
+			catch (Exception e2) {
 				System.out.println("The corpus has no text_id property" + e2); //$NON-NLS-1$
 				org.txm.utils.logger.Log.printStackTrace(e2);
 				return false;
 			}
-
+			
 			Log.fine("Loading line informations...");
-
-			EditorPart l_editor = editor.getLinkedEditor(SynopticEditionEditor.class);
+			
+			SynopticEditionEditor l_editor = editor.getLinkedEditor(SynopticEditionEditor.class);
 			SynopticEditionEditor attachedBrowserEditor = null;
 			if (l_editor != null) {
-				attachedBrowserEditor = (SynopticEditionEditor) l_editor;//associatedEditors.get(editor);
+				attachedBrowserEditor = l_editor;// associatedEditors.get(editor);
 			}
 			
-			if (attachedBrowserEditor!= null && attachedBrowserEditor.isDisposed()) {
+			if (attachedBrowserEditor != null && attachedBrowserEditor.isDisposed()) {
 				associatedEditorsPreviousOtherWordIDs.put(editor, new ArrayList<String>());
 				associatedEditorsPreviousLineids.put(editor, new ArrayList<String>());
 			}
 			List<String> previousOtherWordIDs = associatedEditorsPreviousOtherWordIDs.get(editor);
 			List<String> previousLineids = associatedEditorsPreviousLineids.get(editor);
-
+			
 			if (attachedBrowserEditor == null || attachedBrowserEditor.isDisposed()) {
 				String[] editionsToOpen = OpenEdition.getDefaultEditions(corpus);
-
+				
 				if (editionsToOpen.length == 0) { // the defaultEdition parameter is not set
 					List<String> editionNames = corpus.getProject().getEditionNames();
 					if (editionNames.size() > 0) { // use the first edition declared
 						editionsToOpen = new String[1];
 						editionsToOpen[0] = editionNames.get(0);
 						Log.info(NLS.bind(EditionUIMessages.openingWithFirstEditionNoDefaultEditionSetColonP0, editionNames.get(0)));
-					} else { // no edition in the corpus
+					}
+					else { // no edition in the corpus
 						Log.info(EditionUIMessages.noEditionToOpen);
 						editionsToOpen = new String[0];
 						return false;
 					}
-				} else {
+				}
+				else {
 					Log.fine(NLS.bind(EditionUIMessages.openingDefaultEditionsColonP0, StringUtils.join(editionsToOpen, ", ")));
 				}
-
+				
 				attachedBrowserEditor = OpenEdition.openEdition(corpus, editionsToOpen);
 				editor.addLinkedEditor(attachedBrowserEditor);
 				
 				int position = SynopticEditionPreferences.getInstance().getInt(SynopticEditionPreferences.BACKTOTEXT_POSITION);
 				SWTEditorsUtils.addEditor(editor, attachedBrowserEditor, position);
 			}
-
+			
 			// remove previous highlighted words
 			if (previousOtherWordIDs != null) {
-				//System.out.println("remove previousOtherWordIDs="+previousOtherWordIDs);
+				// System.out.println("remove previousOtherWordIDs="+previousOtherWordIDs);
 				attachedBrowserEditor.removeHighlightWordsById(lightred, previousOtherWordIDs);
 				associatedEditorsPreviousOtherWordIDs.remove(editor); // free mem
 			}
 			if (previousLineids != null) {
-				//System.out.println("remove previousLineids="+previousLineids);
+				// System.out.println("remove previousLineids="+previousLineids);
 				attachedBrowserEditor.removeHighlightWordsById(red, previousLineids);
 				associatedEditorsPreviousLineids.remove(editor); // free mem
 			}
-
-			//System.out.println("getKeywordsId from "+editor.getTopLine()+" to "+editor.getBottomLine() + 1);
+			
+			// System.out.println("getKeywordsId from "+editor.getTopLine()+" to "+editor.getBottomLine() + 1);
 			List<String> otherWordIDs = conc.getKeywordsId(textid, editor.getTopLine(), editor.getBottomLine() + 1);
-			//System.out.println("getKeywordsId="+otherWordIDs);
+			// System.out.println("getKeywordsId="+otherWordIDs);
 			List<String> lineids = null;
 			try {
 				lineids = org.txm.searchengine.cqp.corpus.query.Match.getValuesForProperty(corpus.getProperty("id"), match); //$NON-NLS-1$
-			} catch (Exception e1) {
+			}
+			catch (Exception e1) {
 				org.txm.utils.logger.Log.printStackTrace(e1);
 				return false;
 			}
 			Log.fine(NLS.bind("Project id {0} Corpus (Base) id {1} Text id {2}",  //$NON-NLS-1$
-					new Object[]{projectid, baseid, textid}));
-
-			otherWordIDs.removeAll(lineids); // remove the pivot from others words 
-
+					new Object[] { projectid, baseid, textid }));
+			
+			otherWordIDs.removeAll(lineids); // remove the pivot from others words
+			
 			Text text = corpus.getProject().getText(textid);
 			if (text == null) {
 				StatusLine.setMessage(NLS.bind("BackToText: Text {0} is missing", textid)); //$NON-NLS-1$
 				Log.severe(NLS.bind("BackToText: Text {0} is missing", textid)); //$NON-NLS-1$
 				return false;
 			}
-
+			
 			String line_wordid = lineids.get(0);
 			if (line_wordid == null) {
 				Log.severe(EditionUIMessages.errorColonCouldNotRetrieveLineWordIdsAbortingBackToText);
-				return false;				
+				return false;
 			}
-
-
+			
+			
 			String focusid = null;
 			if (lineids.size() > 0) focusid = lineids.get(0);
-
-			//System.out.println("add otherWordIDs="+otherWordIDs);
+			
+			// System.out.println("add otherWordIDs="+otherWordIDs);
 			attachedBrowserEditor.addHighlightWordsById(lightred, otherWordIDs);
-
-			//System.out.println("add linesids="+lineids);
+			
+			// System.out.println("add linesids="+lineids);
 			attachedBrowserEditor.addHighlightWordsById(red, lineids);
-
+			
 			associatedEditorsPreviousOtherWordIDs.put(editor, otherWordIDs);
 			associatedEditorsPreviousLineids.put(editor, lineids);
-
-			HashSet<int[]> posses = new HashSet<int[]>();
+			
+			HashSet<int[]> posses = new HashSet<>();
 			posses.add(pos);
 			attachedBrowserEditor.setHighlightedArea(posses);
-
+			
 			attachedBrowserEditor.setFocusedWordID(focusid);
-
+			
 			// reload the page and styles
 			attachedBrowserEditor.backToText(text, line_wordid);// open the page(S) containing the word with id=line_wordid
-
+			
 			IWorkbenchPage attachedPage = attachedBrowserEditor.getEditorSite().getPage();
 			attachedPage.activate(attachedBrowserEditor);
-
+			
 			return true;
-
-		} catch (Exception err) {
+			
+		}
+		catch (Exception err) {
 			Log.severe(NLS.bind("** Text display failed: {0}", err)); //$NON-NLS-1$
 			Log.printStackTrace(err);
 		}
 		return false;
 	}
-}
\ No newline at end of file
+}
